/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-cob-light-0.5.5-0raring-20150331-0426/msg/LightMode.msg
 *
 */


#ifndef COB_LIGHT_MESSAGE_LIGHTMODE_H
#define COB_LIGHT_MESSAGE_LIGHTMODE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/ColorRGBA.h>

namespace cob_light
{
template <class ContainerAllocator>
struct LightMode_
{
  typedef LightMode_<ContainerAllocator> Type;

  LightMode_()
    : mode(0)
    , color()
    , frequency(0.0)
    , timeout(0.0)
    , pulses(0)
    , priority(0)  {
    }
  LightMode_(const ContainerAllocator& _alloc)
    : mode(0)
    , color(_alloc)
    , frequency(0.0)
    , timeout(0.0)
    , pulses(0)
    , priority(0)  {
    }



   typedef uint8_t _mode_type;
  _mode_type mode;

   typedef  ::std_msgs::ColorRGBA_<ContainerAllocator>  _color_type;
  _color_type color;

   typedef float _frequency_type;
  _frequency_type frequency;

   typedef float _timeout_type;
  _timeout_type timeout;

   typedef int32_t _pulses_type;
  _pulses_type pulses;

   typedef int8_t _priority_type;
  _priority_type priority;


    enum { NONE = 0 };
     enum { STATIC = 1 };
     enum { FLASH = 2 };
     enum { BREATH = 3 };
     enum { BREATH_COLOR = 4 };
     enum { FADE_COLOR = 5 };
 

  typedef boost::shared_ptr< ::cob_light::LightMode_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::cob_light::LightMode_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct LightMode_

typedef ::cob_light::LightMode_<std::allocator<void> > LightMode;

typedef boost::shared_ptr< ::cob_light::LightMode > LightModePtr;
typedef boost::shared_ptr< ::cob_light::LightMode const> LightModeConstPtr;

// constants requiring out of line definition

   

   

   

   

   

   



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::cob_light::LightMode_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::cob_light::LightMode_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace cob_light

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg'], 'actionlib_msgs': ['/opt/ros/hydro/share/actionlib_msgs/cmake/../msg'], 'cob_light': ['/tmp/buildd/ros-hydro-cob-light-0.5.5-0raring-20150331-0426/msg', '/tmp/buildd/ros-hydro-cob-light-0.5.5-0raring-20150331-0426/obj-x86_64-linux-gnu/devel/share/cob_light/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::cob_light::LightMode_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::cob_light::LightMode_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::cob_light::LightMode_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::cob_light::LightMode_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::cob_light::LightMode_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::cob_light::LightMode_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::cob_light::LightMode_<ContainerAllocator> >
{
  static const char* value()
  {
    return "5c61cdd41b56356f16e4e7ab38a77236";
  }

  static const char* value(const ::cob_light::LightMode_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x5c61cdd41b56356fULL;
  static const uint64_t static_value2 = 0x16e4e7ab38a77236ULL;
};

template<class ContainerAllocator>
struct DataType< ::cob_light::LightMode_<ContainerAllocator> >
{
  static const char* value()
  {
    return "cob_light/LightMode";
  }

  static const char* value(const ::cob_light::LightMode_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::cob_light::LightMode_<ContainerAllocator> >
{
  static const char* value()
  {
    return "uint8 mode\n\
uint8 NONE = 0 			# will turn everything off\n\
uint8 STATIC = 1 		# will change the LEDs to \"color\"\n\
uint8 FLASH = 2 		# will change the LEDs frequently with \"frequency\" from \"color\" to black\n\
uint8 BREATH = 3 		# will change the LEDs smoothly with \"frequency\" from \"color\" to black\n\
uint8 BREATH_COLOR = 4 	# will change the LEDs smoothly with \"frequency\" from \"color\" to black\n\
						# and flips color in time\n\
uint8 FADE_COLOR = 5 	# will fade the colors in rainbow\n\
\n\
std_msgs/ColorRGBA color #the color which will be used\n\
float32 frequency 		# in Hz\n\
float32 timeout 		# in s, requested mode will be executed for max timout s.\n\
						# default is 0 and meens no timeout.\n\
int32 pulses 			# spezifies the amount of pulses which will be executed.\n\
			 			# eg: mode = flash, pulses = 2. Meens the light will flash two times\n\
int8 priority 			# priority [-20,20] default = 0. Modes with same or higher priorities will \n\
						# be executed.\n\
================================================================================\n\
MSG: std_msgs/ColorRGBA\n\
float32 r\n\
float32 g\n\
float32 b\n\
float32 a\n\
";
  }

  static const char* value(const ::cob_light::LightMode_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::cob_light::LightMode_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.mode);
      stream.next(m.color);
      stream.next(m.frequency);
      stream.next(m.timeout);
      stream.next(m.pulses);
      stream.next(m.priority);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct LightMode_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::cob_light::LightMode_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::cob_light::LightMode_<ContainerAllocator>& v)
  {
    s << indent << "mode: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.mode);
    s << indent << "color: ";
    s << std::endl;
    Printer< ::std_msgs::ColorRGBA_<ContainerAllocator> >::stream(s, indent + "  ", v.color);
    s << indent << "frequency: ";
    Printer<float>::stream(s, indent + "  ", v.frequency);
    s << indent << "timeout: ";
    Printer<float>::stream(s, indent + "  ", v.timeout);
    s << indent << "pulses: ";
    Printer<int32_t>::stream(s, indent + "  ", v.pulses);
    s << indent << "priority: ";
    Printer<int8_t>::stream(s, indent + "  ", v.priority);
  }
};

} // namespace message_operations
} // namespace ros

#endif // COB_LIGHT_MESSAGE_LIGHTMODE_H
